import math;
import markers;
import geometry;
import patterns;
import labelpath;
import graph ;
//pour une sortie pdf :
settings.outformat="pdf";
//texpreamble("\usepackage[T1]{fontenc}\usepackage[french]{babel}\DecimalMathComma");//pour charger des packages avec options
usepackage("siunitx", "locale=DE");
usepackage("amsmath");
real unite=1;
unitsize(1cm,1cm);
real w=0.6*linewidth(); 
// crée un crayon pour des points tous les a mm
//pen p=0.2pt+linetype("0"+ string(0.5mm),offset=0,scale=false,adjust=false);
pen p=.2mm+linetype("0 "+ string(0.425mm),offset=0,scale=false,adjust=false);
pen q=.5pt+linetype("0 "+ string(0.8mm),offset=0,scale=false,adjust=false);

real xmin=-3,xmax=8; 
real ymin=-1.5,ymax=1.5; 
xlimits(xmin,xmax);
ylimits(ymin,ymax);
//Ticks("%") pour n'avoir que les trait
//Ticks(scale(.75)*Label(Fill(white)),... pour avoir un espace blanc dans le fond des labels
//xaxis(axis=YEquals(0),xmin=xmin,xmax=xmax,Ticks(scale(.75)*Label(Fill(white)),beginlabel=false,endlabel=false,Step=1,step=0.5,Size=1.2mm,size=0.5mm,OmitTick(xmin,xmax)),p=linewidth(0.9pt)+black,true,arrow=Arrow(HookHead));
// on rajoute Format("%") pour avoir que les graduations sans les lables
xaxis(axis=YEquals(0),xmin=xmin,xmax=xmax,Ticks(scale(.75)*Label(Fill(white)),Format("%"),beginlabel=false,endlabel=false,Step=1,step=0.5,Size=1.2mm,size=0.5mm,OmitTick(xmin,xmax)),p=linewidth(0.9pt)+black,true,arrow=Arrow(HookHead));
//marquage d'un point avec abscisse
real ecartv=1.5;

//pair O=(0,0);
//labelx("$O$",O,ecartv*N,red);//marquage du point
//labelx("$0$",O,ecartv*S,red);// marquage de son abscisse
//draw(O--O+(0.01,0),CircleBarIntervalMarker(2,0,angle=0,radius=0.9mm,bp+red,filltype=Fill(red),dotframe(purple)));
pair A=(2.7,0);

real r=4.5;
labelx("centre",A+(0,0.35),ecartv*N,blue);//marquage du point
labelx("$c=\frac{a+b}{2}$",A,ecartv*S,blue);// marquage de son abscisse
draw(A--A+(0.01,0),CircleBarIntervalMarker(2,0,angle=0,radius=0.8mm,bp+blue,filltype=Fill(blue),dotframe(blue)));
//ou une croix angle=45 pour avoir un + et angle=0 pour avoir un x
//draw(A--A+(0.01,0),CrossIntervalMarker(2,4,size=2mm,angle=0,bp+brown,dotframe(brown)));
//marquage d'un point avec abscisse
pair B=(xpart(A)+r,0);
draw((xpart(B)-0.2,-0.3)--(xpart(B),-0.3)--(xpart(B),0.3)--(xpart(B)-0.2,0.3),1bp+red);
//labelx("$R_1$",B,ecartv*N,brown);//marquage du point
labelx("$b$",B,ecartv*S,brown);// marquage de son abscisse
draw(B--B+(0.01,0),CircleBarIntervalMarker(2,0,angle=0,radius=0.8mm,bp+blue,filltype=Fill(brown),dotframe(purple)));
pair C=(xpart(A)-r,0);
draw((xpart(C)+0.2,-0.3)--(xpart(C),-0.3)--(xpart(C),0.3)--(xpart(C)+0.2,0.3),1bp+red);
//labelx("$R_2$",C,ecartv*N,brown);//marquage du point
labelx("$a$",C,ecartv*S,brown);// marquage de son abscisse
draw(C--C+(0.01,0),CircleBarIntervalMarker(2,0,angle=0,radius=0.8mm,bp+blue,filltype=Fill(brown),dotframe(purple)));
pair M=(xpart(A)-0.7*r,0);
//labelx("$M$",M,ecartv*N,brown);//marquage du point
//labelx("$x$",M,ecartv*S,brown);// marquage de son abscisse
//draw(M--M+(0.01,0),CircleBarIntervalMarker(2,0,angle=0,radius=0.8mm,bp+blue,filltype=Fill(brown),dotframe(purple)));
//distance("$|x-a|$", M,A, 8mm, darkgray);
//dot((0,0));
draw(A..((xpart(A)+xpart(B))/2,0.5)..B,1bp+red+dashed,ArcArrow(SimpleHead)); 
labelx("rayon $r=\frac{d(a\,;\,b)}{2}$",((xpart(A)+xpart(B))/2,0.5),N,red);
draw(A..((xpart(A)+xpart(C))/2,0.5)..C,1bp+red+dashed,ArcArrow(SimpleHead));
labelx("rayon $r=\frac{d(a\,;\,b)}{2}$",((xpart(A)+xpart(C))/2,0.5),N,red);
xlimits(xmin,xmax,Crop);
ylimits(ymin,ymax,Crop);
//shipout(bbox(0.1cm,0.1cm,white));
